package laskuri3;

import java.awt.*;
import javax.swing.JButton;
import java.awt.event.ActionEvent;
import java.io.*;

/**
 * <p>Title: EventBeanLaskuri</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: University of Jyvskyl</p>
 * @author Miika Nurminen
 * @version 1.0
 *
 * LisButton - esimerkki propertyn kytst JavaBeanissa
 */

public class LisaaButton extends JButton implements java.awt.event.ActionListener {
  BorderLayout borderLayout1 = new BorderLayout();
  private BeanLaskuri laskuri = null;

  public LisaaButton() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
  }
  public BeanLaskuri getLaskuri() {
    return laskuri;
  }
  public void setLaskuri(BeanLaskuri lask) {
    if (lask==laskuri) return;
    BeanLaskuri oldLaskuri=laskuri;

    // Kun laskuriin ei en osoiteta, tapahtumakuuntelijaa ei tarvita
    if ((laskuri!=null) && (lask==null)) this.removeActionListener(this);

    laskuri = lask;

    // osoitettaessa laskuriin ensimmist kertaa listn tapahtumakuuntelija
    if ((oldLaskuri==null) && (lask!=null)) this.addActionListener(this);
  }

  public void actionPerformed(ActionEvent actionEvent) {
    if (laskuri==null) return; // tmn ei pitisi tapahtua... :-)

    laskuri.inc(1);
  }
}